#include "defines.h"
#include "intr.h"
#include "interrupt.h"

static softvec_handler_t softvecs[SOFTVEC_TYPE_NUM];

/* եȥߥ٥ν */
int softvec_init(void)
{
  int type;
  for (type = 0; type < SOFTVEC_TYPE_NUM; type++)
    softvec_setintr(type, NULL);
  return 0;
}

/* եȥߥ٥ */
int softvec_setintr(softvec_type_t type, softvec_handler_t handler)
{
  softvecs[type] = handler;
  return 0;
}

/*
 * ̳ߥϥɥ顥
 * եȥߥ٥򸫤ơƥϥɥʬ롥
 */
void interrupt(softvec_type_t type, uint16 sp)
{
  softvec_handler_t handler = softvecs[type];
  if (handler)
    handler(type, sp);
}
