	.section .text
	.global	_start
#	.type	_start,@function
_start:
	mov.w	#_bootstack,sp

#ifdef DEBUG // --------------------------------------------------------------
xxx_clear:
	mov.w	#_data_start, r2
	mov.w	#_intrstack, r3
	mov.w	#0xdead, r0

xxx_clear_loop:
	mov.w	r0, @r2
	adds	#2, r2

	cmp.w	r2, r3
	bgt	xxx_clear_loop
#endif // --------------------------------------------------------------------

data_copy:
	mov.w	#_data_org, r1
	mov.w	#_data_start, r2
	mov.w	#_edata, r3

	cmp.w	r2, r3		// .datä悪ꑶ݂Ȃꍇ̕ی
	ble	bss_clear
data_copy_loop:
	mov.b	@r1+, r0l
	mov.b	r0l, @r2
	adds	#1, r2

	cmp.w	r2, r3
	bgt	data_copy_loop

bss_clear:
	mov.w	#_bss_start, r2
	mov.w	#_ebss, r3
	sub.w	r0, r0

	cmp.w	r2, r3		// .bss̈悪ꑶ݂Ȃꍇ̕ی
	ble	kozos_start
bss_clear_loop:
	mov.b	r0l, @r2
	adds	#1, r2

	cmp.w	r2, r3
	bgt	bss_clear_loop

kozos_start:
	sub.w	r0, r0
	jsr	@_serial_init	// fobOpVA|[g

	jsr	@_main

1:
	bra	1b

	.global	_dispatch
#	.type	_dispatch,@function
_dispatch:
	mov.w	@r0,r7
	mov.w	@r7+,r0
	mov.w	@r7+,r1
	mov.w	@r7+,r2
	mov.w	@r7+,r3
	mov.w	@r7+,r4
	mov.w	@r7+,r5
	mov.w	@r7+,r6
	rte
